/**
 * @file
 * Drupal behavior to run gardengnome player plugins.
 */
(function($, Drupal){

  // Helper to calculate natural width and height of an image.
  var props = ['Width', 'Height'], prop;
  while (prop = props.pop()) {
    (function (natural, prop) {
      $.fn[natural] = (natural in new Image()) ?
        function () {
          return this[0][natural];
        } :
        function () {
          var node = this[0];
          var img;
          var value;

          if (node.tagName.toLowerCase() === 'img') {
            img = new Image();
            img.src = node.src;
            value = img[prop];
          }
          return value;
        };
    }('natural' + prop, prop.toLowerCase()));
  }

  // Gardengnome player behavior.
  Drupal.behaviors.gardengnome_player = {
    attach: function(context, settings) {
      // Trigger Popups
      $('.gardengnome-player', context).once(function(){
        var $el = $(this);
        if ($el.data('display') === 'popup') {
          // Don't event attach the player for popup windows.
          $el.click(function(event){
            var width = parseInt($(this).attr('data-popup-width'), 10);
            var height = parseInt($(this).attr('data-popup-height'), 10);
            var params = [
              'toolbar=0',
              'scrollbars=0',
              'location=0',
              'status=0',
              'menubar=0',
              'width=' + width,
              'height=' + height
            ].join(',');
            var file = $el.data('package').split('/').pop();
            var popup = window.open(Drupal.settings.basePath + 'gardengnome-player-popup?package=' + file, 'Gardengnome Player', params);
            popup.moveTo(Math.floor(screen.width/2 - width/2), Math.floor(screen.height/2 - height/2));
            event.preventDefault();
          });
        }
        else {
          // Attach the player to inline displays.
          $(window).load(function(){
            var $preview = $el.find('.gardengnome-player-preview');
            $el.gardengnomePlayer({width: $preview.naturalWidth(), height: $preview.naturalHeight()});
          });
        }
      });
    }
  };
}(jQuery, Drupal));