<?php
/**
 * @file
 * Implement an gardengnome player field, based on the file module's file field.
 */

/**
 * Implements hook_field_info().
 */
function gardengnome_player_field_info() {
  return array(
    'gardengnome_package' => array(
      'label' => t('Gardengnome Package'),
      'description' => t('An Gardengnome Object2VR or Pano2VR package file.'),
      'settings' => array(
        'uri_scheme' => variable_get('file_default_scheme', 'public'),
      ),
      'instance_settings' => array(
        'file_extensions' => 'ggpkg',
        'file_directory' => '',
      ),
      'default_widget' => 'gardengnome_package',
      'default_formatter' => 'gardengnome_package',
    ),
  );
}

/**
 * Implements hook_field_load().
 */
function gardengnome_player_field_load($entity_type, $entities, $field, $instances, $langcode, &$items, $age) {
  file_field_load($entity_type, $entities, $field, $instances, $langcode, $items, $age);
}

/**
 * Implements hook_field_insert().
 */
function gardengnome_player_field_insert($entity_type, $entity, $field, $instance, $langcode, &$items) {
  file_field_insert($entity_type, $entity, $field, $instance, $langcode, $items);
}

/**
 * Implements hook_field_update().
 */
function gardengnome_player_field_update($entity_type, $entity, $field, $instance, $langcode, &$items) {
  file_field_update($entity_type, $entity, $field, $instance, $langcode, $items);
}

/**
 * Implements hook_field_delete().
 */
function gardengnome_player_field_delete($entity_type, $entity, $field, $instance, $langcode, &$items) {
  file_field_delete($entity_type, $entity, $field, $instance, $langcode, $items);
}

/**
 * Implements hook_field_delete_revision().
 */
function gardengnome_player_field_delete_revision($entity_type, $entity, $field, $instance, $langcode, &$items) {
  file_field_delete_revision($entity_type, $entity, $field, $instance, $langcode, $items);
}

/**
 * Implements hook_field_is_empty().
 */
function gardengnome_player_field_is_empty($item, $field) {
  return file_field_is_empty($item, $field);
}
